package org.noote.libs.roby.comm;

public class BluetoothCommandProtocol {

	//////////////////////////////////
	///
	/// Only for Roby Arduino Sketch 0.5 !
	///
	/////////////////////////////////
	static final String CMD_START_TRAME = "#";
	static final String CMD_END_TRAME = "$";
	protected static String _bounding(String sCmd)
	{
		return CMD_START_TRAME+sCmd+CMD_END_TRAME;
	}
	
	
	/////////////////////////////////
	// Version
	static final String CMD_VERSION = "v";
	public static String sendAskVersion()
	{
		return _bounding(CMD_VERSION);
	}

	/////////////////////////////////
	// Setting
	static final String CMD_SETTING = "g";
	public static String sendAskSetting()
	{
		return _bounding(CMD_SETTING+"a-");
	}
	public static String sendAskSettingBody()
	{
		return _bounding(CMD_SETTING+"ab");
	}
	public static String sendAskSettingTurrel()
	{
		return _bounding(CMD_SETTING+"at");
	}

	/////////////////////////////////
	// Status
	static final String CMD_STATUS = "s";
	public static String sendAskStatus()
	{
		return _bounding(CMD_STATUS+"a-");
	}
	public static String sendAskStatusSensors()
	{
		return _bounding(CMD_STATUS+"as");
	}
	public static String sendAskStatusTurrel()
	{
		return _bounding(CMD_STATUS+"at");
	}
	public static String sendAskStatusBody()
	{
		return _bounding(CMD_STATUS+"ab");
	}
	public static String sendSetSendStatus(boolean bSet)
	{
		return _bounding(CMD_STATUS+"ss"+(bSet?"1":"0"));
	}

	/////////////////////////////////
	// Reset
	static final String CMD_RESET = "r";
	public static String sendReset()
	{
		return _bounding(CMD_RESET+"-");
	}
	public static String sendResetBody()
	{
		return _bounding(CMD_RESET+"b");
	}
	public static String sendResetTurrel()
	{
		return _bounding(CMD_RESET+"t");
	}

	/////////////////////////////////
	// Body
	static final String CMD_BODY = "b";
	public static String sendBodyFront(int iSpeed)
	{
		String sSpeed = (iSpeed<0)?"0":(iSpeed>100)?"100":Integer.toString(iSpeed);
		if(iSpeed>0) sSpeed = "+"+sSpeed;
		return _bounding(CMD_BODY+"m"+"11"+sSpeed+sSpeed);
	}
	public static String sendBodyBack(int iSpeed)
	{
		String sSpeed = (iSpeed<0)?"0":(iSpeed>100)?"100":Integer.toString(iSpeed);
		if(iSpeed>0) sSpeed = "+"+sSpeed;
		return _bounding(CMD_BODY+"m"+"00"+sSpeed+sSpeed);
	}
	public static String sendBodyLeft(int iSpeed)
	{
		String sSpeed = (iSpeed<0)?"0":(iSpeed>100)?"100":Integer.toString(iSpeed);
		if(iSpeed>0) sSpeed = "+"+sSpeed;
		return _bounding(CMD_BODY+"m"+"10"+sSpeed+sSpeed);
	}
	public static String sendBodyRight(int iSpeed)
	{
		String sSpeed = (iSpeed<0)?"0":(iSpeed>100)?"100":Integer.toString(iSpeed);
		if(iSpeed>0) sSpeed = "+"+sSpeed;
		return _bounding(CMD_BODY+"m"+"01"+sSpeed+sSpeed);
	}

	/////////////////////////////////
	// Turrel
	static final String CMD_TURREL = "t";
	public static String sendTurrelSetPosition(short low, short high)
	{
		String sLow = Integer.toString(low);
		String sHigh = Integer.toString(high);
		if(low>0) sLow = "+"+sLow;
		if(high>0) sHigh = "+"+sHigh;
		return _bounding(CMD_TURREL+"p"+sLow+sHigh);
	}
	public static String sendTurrelScanPosition(short low, short high)
	{
		String sLow = Integer.toString(low);
		String sHigh = Integer.toString(high);
		if(low>0) sLow = "+"+sLow;
		if(high>0) sHigh = "+"+sHigh;
		return _bounding(CMD_TURREL+"sp"+sLow+sHigh);
	}
	public static String sendTurrelScanLine(short low_beg, short low_end, short low_step, short high)
	{
		String sLowBeg = Integer.toString(low_beg);
		String sLowEnd = Integer.toString(low_end);
		String sLowStep = Integer.toString(low_step);
		String sHigh = Integer.toString(high);
		if(low_beg>0) sLowBeg = "+"+sLowBeg;
		if(low_end>0) sLowEnd = "+"+sLowEnd;
		if(low_step>0) sLowStep = "+"+sLowStep;
		if(high>0) sHigh = "+"+sHigh;
		return _bounding(CMD_TURREL+"sl"+sLowBeg+sLowEnd+sLowStep+sHigh);
	}
	public static String sendTurrelScanZone(short low_beg, short low_end, short low_step, short high_beg, short high_end, short high_step)
	{
		String sLowBeg = Integer.toString(low_beg);
		String sLowEnd = Integer.toString(low_end);
		String sLowStep = Integer.toString(low_step);
		String sHighBeg = Integer.toString(high_beg);
		String sHighEnd = Integer.toString(high_end);
		String sHighStep = Integer.toString(high_step);
		if(low_beg>0) sLowBeg = "+"+sLowBeg;
		if(low_end>0) sLowEnd = "+"+sLowEnd;
		if(low_step>0) sLowStep = "+"+sLowStep;
		if(high_beg>0) sHighBeg = "+"+sHighBeg;
		if(high_end>0) sHighEnd = "+"+sHighEnd;
		if(high_step>0) sHighStep = "+"+sHighStep;
		return _bounding(CMD_TURREL+"sz"+sLowBeg+sLowEnd+sLowStep+sHighBeg+sHighEnd+sHighStep);
	}
}
