package org.noote.robot_remote;

import org.noote.libs.bluetooth.DeviceList_Activity;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

public class RobotRemote_Activity extends Activity {
	private static final int GETTING_DEVICE = 0;
	private static final int REQUEST_ENABLE_BT = 1;
	private static final int READY_TO_NEXT = 2;

	BluetoothAdapter mBluetoothAdapter = null;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button buttonScan = (Button)findViewById(R.id.buttonScan);
        buttonScan.setOnClickListener(new OnClickListener()
        {
			@Override
			public void onClick(View v) {
	           Intent intent = new Intent(getApplicationContext(), DeviceList_Activity.class);
	           startActivityForResult(intent, GETTING_DEVICE);
			}
        });
        Button buttonConnection = (Button)findViewById(R.id.buttonConnection);
        buttonConnection.setOnClickListener(new OnClickListener()
        {
			@Override
			public void onClick(View v) {
	           LaunchConnection();
			}
        });
        LinearLayout layoutSelect = (LinearLayout)findViewById(R.id.layoutSelect);
    	layoutSelect.setVisibility(View.VISIBLE);
        LinearLayout layoutConnection = (LinearLayout)findViewById(R.id.layoutConnection);
		layoutConnection.setVisibility(View.GONE);

        GetAdapter();
    }

	protected void LaunchConnection() {
		
		Connect();
	}

	@Override
    public void onStart() {
        super.onStart();

		if (!mBluetoothAdapter.isEnabled()) {
		    Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
		    startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
		    return;
		}
	}
	
	@Override
	protected void onActivityResult (int requestCode, int resultCode, Intent data)
	{
		switch(requestCode)
		{
		case REQUEST_ENABLE_BT:
			if(resultCode == RESULT_OK)
			{
				Connect();
			}
			break;
		case GETTING_DEVICE:
			if(resultCode == RESULT_OK)
			{
				String sAddressDevice = data.getStringExtra(DeviceList_Activity.EXTRA_DEVICE_ADDRESS);
				TextView textAddressDevice = (TextView)findViewById(R.id.textAddressDevice);
				textAddressDevice.setText(sAddressDevice);
		        
				LinearLayout layoutSelect = (LinearLayout)findViewById(R.id.layoutSelect);
		    	layoutSelect.setVisibility(View.GONE);
				LinearLayout layoutConnection = (LinearLayout)findViewById(R.id.layoutConnection);
				layoutConnection.setVisibility(View.VISIBLE);
			}
			break;
		case READY_TO_NEXT:
			if(resultCode == RESULT_OK)
			{
				LinearLayout layoutSelect = (LinearLayout)findViewById(R.id.layoutSelect);
		    	layoutSelect.setVisibility(View.GONE);
				LinearLayout layoutConnection = (LinearLayout)findViewById(R.id.layoutConnection);
				layoutConnection.setVisibility(View.VISIBLE);
			}
			break;
		}
	}

	private void GetAdapter() {
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		if (mBluetoothAdapter == null) {
		    Toast.makeText(this, "No bluetooth adapter :(", Toast.LENGTH_LONG); 
			return;
		}
	}


    private void Connect() {
    	String sAddressDevice = ((TextView)findViewById(R.id.textAddressDevice)).getText().toString();
    	if(BluetoothAdapter.checkBluetoothAddress(sAddressDevice))
    	{
	    	Bundle bundle = new Bundle();
	    	bundle.putString(Remote_Activity.BT_ADDRESS_DEVICE, sAddressDevice);
    		Intent intent = new Intent(getApplicationContext(), Remote_Activity.class);
    		intent.putExtras(bundle);    		
            startActivityForResult(intent, READY_TO_NEXT);    		
    	}
	}
}